VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Ohjelma puukartan ja numerolappujen tulostamiseen; Hyde 2013 viritys"
   ClientHeight    =   6405
   ClientLeft      =   225
   ClientTop       =   855
   ClientWidth     =   9060
   LinkTopic       =   "Form1"
   ScaleHeight     =   6405
   ScaleWidth      =   9060
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   120
      Top             =   4200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu Tiedosto 
      Caption         =   "Tiedosto"
      Begin VB.Menu Avaa_DTM 
         Caption         =   "Avaa DTM-tiedosto"
      End
      Begin VB.Menu Avaa_Ja_Piirra_PDF 
         Caption         =   "Avaa puutiedosto PDF-karttaa varten"
      End
      Begin VB.Menu Numerolaput 
         Caption         =   "Avaa puutiedosto PDF numerolappujen tekoon"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Avaa_DTM_Click()

MsgBox (CurDir())
Dim i As Integer, j As Integer
Close (1)
    CommonDialog1.DialogTitle = "Header file for a height model"
    CommonDialog1.Filter = "HDR files (*.hdr)|*.hdr"
    CommonDialog1.Action = 1
    DemFileName = CommonDialog1.Filename
    Open DemFileName For Input As 1

Form1.MousePointer = 11
DoEvents

Form1.Caption = CommonDialog1.Filename
Input #1, Zmodel.ncols
Input #1, Zmodel.nrows
Input #1, Zmodel.xllcorner
Input #1, Zmodel.yllcorner
Input #1, Zmodel.CellSize
Input #1, Zmodel.nodata_value
Input #1, Zmodel.filepath

Close (1)

ReDim ZfXY(0 To Zmodel.ncols - 1, 0 To Zmodel.nrows - 1) As Single
ReDim row(0 To Zmodel.ncols - 1) As Single
ReDim rowi(0 To Zmodel.ncols - 1) As Integer
ReDim rowb(0 To Zmodel.ncols - 1) As Byte

Dim place As Long

'DEMTYPE = "RAWBINARY"
'DEMTYPE = "KORPELA"
DEMTYPE = "ISENBURG"
Select Case DEMTYPE

Case "RAWBINARY"
Open Zmodel.filepath For Binary As 1
For i = 0 To Zmodel.nrows - 1
   Rem Compute position in file
   place = 1 + (i * (Zmodel.ncols)) * 1
   Rem Read a row of 4-byte floats (singles)
   Get #1, place, rowb()
   Rem Assign values to the DEM, Addval is the BIAS in your model
   For j = 0 To Zmodel.ncols - 1
   ZfXY(j, i) = CSng(rowb(j)) + Addval
   
   Next j
 Next i
 Close (1)

Case "KORPELA"
Open Zmodel.filepath For Binary As 1
For i = 0 To Zmodel.nrows - 1
   Rem Compute position in file
   place = 1 + (i * (Zmodel.ncols)) * 4
   Rem Read a row of 4-byte floats (singles)
   Get #1, place, row()
   Rem Assign values to the DEM, Addval is the BIAS in your model
   For j = 0 To Zmodel.ncols - 1
   ZfXY(j, i) = CSng(row(j)) + Addval
   Next j
 Next i
 Close (1)
 
Case "ISENBURG"
Open Zmodel.filepath For Binary As 1
For i = 0 To Zmodel.nrows - 1
 Rem The file is flipped upside down
 ii = Zmodel.nrows - 1 - i
 Rem Position in file, two-byte integers
 place = 1 + (i * (Zmodel.ncols)) * 2
 Rem Read a row of integers
 Get #1, place, rowi()
 Rem Assign values, convert integers to 0.01 m accuracy
  For j = 0 To Zmodel.ncols - 1
   ZfXY(j, ii) = 0.01 * CSng(rowi(j))
   If ZfXY(j, ii) > zMax Then zMax = ZfXY(j, ii)
  Next j
 Next i
 Close (1)
End Select

Form1.Caption = " DEM read succesfully"
Form1.MousePointer = 1
DoEvents
Exit Sub

End Sub

Private Sub Avaa_Ja_Piirra_PDF_Click()

Dim nlabel As Integer, ntree As Integer, track As Integer, spec As Integer
Dim state As Integer, X As Double, Y As Double, z As Double
Dim D As Double, H As Double
Dim stumps As Boolean
ReDim plots(1 To 224) As Plot_info

CommonDialog1.Filter = "Field plot data files (*.*)|*.*"
CommonDialog1.DialogTitle = "##.txt puutiedosto"
CommonDialog1.Action = 1
Open CommonDialog1.Filename For Input As 1
Dim Cfilename As String

Cfilename = CommonDialog1.Filename
Input #1, plot, ntree, spec, X, Y, z, z_gnd, Lidar_h, Foto_h, d13, Status, sigmaX, sigmaY, geoloctype, statusnew, subplot, Strip
Close (1)

Rem Plot center is plots(plot).x, and plots(plot).y
Dim x_test As Double, Y_test As Double
Dim x_utm As Double, y_utm As Double
Dim Z_min As Double, Z_max As Double

Rem Find center of gravity, mean d13, number of measured trees, min and max for x and y
x_test = 0: Y_test = 0
Dim n, n_measured, ltm_test As Integer
Dim x_max, y_max, x_min, y_min, mean_d13, ppaSum As Double
x_min = 9999999
y_min = 9999999
Z_min = 9999999
x_max = -9999999
y_max = -9999999
Z_max = -9999999
mean_d13 = 0
ppaSum = 0
n_measured = 0
Open Cfilename For Input As 1
Do Until EOF(1)
 Input #1, plot, ntree, spec, X, Y, z, z_gnd, Lidar_h, Foto_h, d13, Status, sigmaX, sigmaY, geoloctype, statusnew, subplot, Strip
 x_test = x_test + X: Y_test = Y_test + Y
 If X < x_min Then x_min = X
 If Y < y_min Then y_min = Y
 If z_gnd < Z_min Then Z_min = z_gnd
 If X > x_max Then x_max = X
 If Y > y_max Then y_max = Y
 If z_gnd > Z_max Then Z_max = z_gnd
 n = n + 1
 If (d13 > 0 And Status > 0) Then
    n_measured = n_measured + 1
    mean_d13 = mean_d13 + d13 ^ 2 * d13
    ppaSum = ppaSum + d13 ^ 2
 End If
Loop
Close (1)
x_test = x_test / n: Y_test = Y_test / n: mean_d13 = mean_d13 / ppaSum
x_min = x_min: y_min = y_min: x_max = x_max: y_max = y_max
Ltm = 3200 / (x_max - x_min)
ltm_test = 3200 / (y_max - y_min)
If ltm_test < Ltm Then Ltm = ltm_test
DTM_width = Ltm * 0.08
DTM_height = Ltm * 0.08

plots(plot).X = x_test
plots(plot).Y = Y_test
x_utm = -2471441.562 + 0.9987798071 * x_test + 0.04612734592 * Y_test
y_utm = 124518.3273 - 0.04613846192 * x_test + 0.9987750048 * Y_test
zmaa = getheight(x_utm, y_utm) - 18.67

stumps = False
Rem Drawing the stem Map, retrieve Printer metrics
apu = Printer.Height
apu = Printer.ScaleTop
apu = Printer.ScaleLeft
apu = Printer.ScaleWidth
apu = Printer.ScaleHeight
apu = Printer.ScaleMode
apu = Printer.TwipsPerPixelX
apu = Printer.TwipsPerPixelY
apu = Printer.CurrentX
apu = Printer.CurrentY
apu = Printer.Width
Rem Variables determinig position and scale
hmargin = Printer.ScaleHeight / 50 - 1000
wmargin = Printer.ScaleWidth / 50 + 1400 '3200 '+ 2300
'Ltm = 35 'Scale Unit factor  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ymax = (Printer.ScaleHeight / Printer.TwipsPerPixelX) * 0.5

' REM A3 300 dpi vs. A4 600 dpi for the labels in pdf-writer!!!

Printer.Circle (10000, 14500), 10
Rem Get the device context
Dim apu1 As Long
apu1 = CLng(Printer.hdc)
Printer.DrawMode = 13
Printer.ForeColor = RGB(0, 0, 0)
Printer.DrawStyle = 0
Printer.FillStyle = 1
Printer.FontName = Arial
Printer.FontSize = 8

Rem Read JETColorMAP
ReDim ColorMap(1 To 64, 1 To 3) As Byte
Dim l As Long
l = 0
Open "C:\data\JetColorMAP.csv" For Input As 2
Do Until EOF(2)
l = l + 1
Input #2, ColorMap(l, 1), ColorMap(l, 2), ColorMap(l, 3)
Loop
Close (2)

Rem Draw DEM !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Printer.DrawWidth = 5
Printer.DrawStyle = 5
MinDTM = Z_min
MaxDTM = Z_max
D = 0.3
Rem Drawing the DEM loops (in x and y)
For x_test = plots(plot).X - DTM_width * 1 To plots(plot).X + DTM_width * 1 Step 0.5
  For Y_test = plots(plot).Y - DTM_height * 1.2 To plots(plot).Y + DTM_height * 1.2 Step 0.5
    x_utm = -2471441.562 + 0.9987798071 * x_test + 0.04612734592 * Y_test
    y_utm = 124518.3273 - 0.04613846192 * x_test + 0.9987750048 * Y_test
    z = getheight(x_utm, y_utm) - 18.67 + 0.27
    If z < 100 Then GoTo nextYtest
    X = x_test - plots(plot).X
    Y = Y_test - plots(plot).Y
    apu_z = 255 - (255 - (z - MinDTM) * 255 / (MaxDTM - MinDTM)) ' DTM
    apu_z = apu_z / 4
    If apu_z < 1 Then apu_z = 1
    If apu_z > 64 Then apu_z = 64
    Printer.ForeColor = RGB(255, 0, 0)
    Printer.FillColor = RGB(ColorMap(apu_z, 1), ColorMap(apu_z, 2), ColorMap(apu_z, 3))
    rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
    rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
    Printer.FillStyle = 0
    Rem next line draw a DEM cell !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    apu = rectangle(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
    Printer.FillStyle = 1
nextYtest:  Next Y_test
Next x_test
Close (2)

Printer.DrawStyle = 0
Printer.DrawWidth = 2
Printer.ForeColor = RGB(0, 0, 0)
Printer.FillColor = RGB(0, 0, 0)

Rem ************
Rem Drawing trees
drawtrees:
n = 0
Open Cfilename For Input As 1
Nin = 0
Dsum = 0

Do Until EOF(1)
 Input #1, plot, ntree, spec, X, Y, z, z_gnd, Lidar_h, Foto_h, d13, Status, sigmaX, sigmaY, geoloctype, statusnew, subplot, Strip
 Nin = Nin + 1
 Dsum = Dsum + d13
 
 X = X - plots(plot).X
 Y = Y - plots(plot).Y
 
 If Status > 0 And d13 > 0 Then
    D = d13 / 1000 + 0.1 ' for visibility add .05 units
 Else
    MsgBox ("No d13 measured!!!!!!!")
 End If
 
 Dim ncount As Long
 lpstring = CStr(ntree)
 ncount = Len(Trim(lpstring))
 If ntree = 0 Then lpstring = ""
 shift = 50
 If spec > 2 And spec < 21 Then spec = 3
 If spec = 21 Then spec = 2
 If Status > 14 Then spec = 4
  
 Select Case spec
 Case 1 ' Pine, draw a box (rectangle)
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(255, 0, 0)
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  Printer.FillStyle = 0
  apu = rectangle(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
   
 Case 2 ' spruce, draw a triangle
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(33, 178, 4)
  triangle(0).X = wmargin + Ltm * X - Ltm * (D):  triangle(0).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  triangle(1).X = wmargin + Ltm * X:   triangle(1).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  triangle(2).X = wmargin + Ltm * X + Ltm * (D):  triangle(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))

  Printer.FillStyle = 0
  apu = Polygon(ByVal apu1, triangle(0), CLng(3))
  Printer.FillStyle = 1
 
 Case 3 ' broadleaved
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(5, 46, 255)
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  Printer.FillStyle = 0
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  
 Case 4 ' dead tree
  l = spec
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(0, 0, 0)
  rectang(0).X = wmargin + Ltm * X - Ltm * (D):  rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D / 2))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D):  rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D / 2))
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  rectang(0).X = wmargin + Ltm * X - Ltm * (D / 2): rectang(0).Y = ymax - (hmargin + Ltm * Y + Ltm * (D))
  rectang(2).X = wmargin + Ltm * X + Ltm * (D / 2): rectang(2).Y = ymax - (hmargin + Ltm * Y - Ltm * (D))
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
 
 End Select

Printer.ForeColor = RGB(0, 0, 0)
Printer.FillColor = RGB(0, 0, 0)

If spec = 4 And ntree < 1000 Then
 Printer.FontUnderline = True
 apu = TextOut(ByVal apu1, ByVal wmargin + Ltm * X, ByVal ymax - (hmargin + Ltm * Y) + Ltm * 1.2 * D, ByVal lpstring, ByVal ncount)
 n = n + 1
 Printer.FontUnderline = False
End If
 
'If stumps = False And state = 11 Then
apu = TextOut(ByVal apu1, ByVal wmargin + Ltm * X, ByVal ymax - (hmargin + Ltm * Y) + Ltm * 1.2 * D, ByVal lpstring, ByVal ncount)
n = n + 1
'End If
nextTree: Loop

Rem *******************
Rem Labeling Section
Dim Box_X
Dim Box_Y
Box_X = 300
Box_Y = 400
Dim apustring As String * 80
Printer.FontSize = 12
apustring = "TreeMap " & Date & " (c) Ilkka Korpela"
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 250, ByVal apustring, ByVal ncount)
'apustring = "Plot number " & CStr(plot) & " with " & Nin & " photo-trees. Mean height: " & Format$(Dsum / Nin, "0.0") & " m"
apustring = "Plot number " & CStr(plot) & " with " & n_measured & " trees. Mean dbh: " & Format$(mean_d13 / 10, "0.0") & " cm"
ncount = Len(apustring)
apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 150, ByVal apustring, ByVal ncount)
'apustring = "Plot coordinates: (" & Format$(plots(plot).X, "0") & "," & Format$(plots(plot).Y, "0") & ") " & " DTM-range: " & Format$(Z_min, "0.0") & " m to " & Format$(Z_max, "0.0") & " m"
'ncount = Len(apustring)
'apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y - 50, ByVal apustring, ByVal ncount)
'Printer.FontSize = 24
'apustring = CStr(plot)
'ncount = Len(apustring)
'apu = TextOut(ByVal apu1, ByVal Box_X + 4000, ByVal Box_Y - 450, ByVal apustring, ByVal ncount)
Printer.FontSize = 12
 
Box_X = 300 + 100

 Printer.DrawWidth = 2
 For k = 1 To 6
 D = 0.2
 Select Case k
 Case 1 ' Pine, draw a box (rectangle)
  rectang(0).X = Box_X - Ltm * (D):  rectang(0).Y = Box_Y + 50 + Ltm * (D)
  rectang(2).X = Box_X + Ltm * (D):  rectang(2).Y = Box_Y + 50 - Ltm * (D)
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(255, 0, 0)
  Printer.FillColor = RGB(255, 0, 0)
  apu = rectangle(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  apustring = "Pine"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 25, ByVal apustring, ByVal 30)
  
 Case 2 ' spruce, draw a triangle
  triangle(0).X = Box_X - Ltm * (D):   triangle(0).Y = Box_Y + 150 + Ltm * (D)
  triangle(1).X = Box_X:   triangle(1).Y = Box_Y + 150 - Ltm * (D)
  triangle(2).X = Box_X + Ltm * (D):  triangle(2).Y = Box_Y + 150 + Ltm * (D)
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(33, 178, 4)
  Printer.FillColor = RGB(33, 178, 4)
  
  apu = Polygon(ByVal apu1, triangle(0), CLng(3))
  Printer.FillStyle = 1
  apustring = "Spruce"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 125, ByVal apustring, ByVal 30)
 
 Case 3 ' silver birch, draw a circle (black)
  rectang(0).X = Box_X - Ltm * (D):  rectang(0).Y = Box_Y + 250 + Ltm * (D)
  rectang(2).X = Box_X + Ltm * (D):  rectang(2).Y = Box_Y + 250 - Ltm * (D)
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(43, 1, 225)
  Printer.FillColor = RGB(43, 1, 225)
  Printer.ForeColor = RGB(5, 46, 255)
  Printer.FillColor = RGB(5, 46, 255)
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  apustring = "Broadleaved"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 225, ByVal apustring, ByVal 30)
  
 Case 4 ' Dead
  l = spec
  Printer.FillStyle = 0
  Printer.ForeColor = RGB(0, 0, 0)
  Printer.FillColor = RGB(0, 0, 0)
  rectang(0).X = Box_X - Ltm * (D):  rectang(0).Y = Box_Y + 350 + Ltm * (D / 2)
  rectang(2).X = Box_X + Ltm * (D):  rectang(2).Y = Box_Y + 350 - Ltm * (D / 2)
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  rectang(0).X = Box_X - Ltm * (D / 2): rectang(0).Y = Box_Y + 350 + Ltm * (D)
  rectang(2).X = Box_X + Ltm * (D / 2): rectang(2).Y = Box_Y + 350 - Ltm * (D)
  apu = Ellipse(ByVal apu1, ByVal rectang(0).X, ByVal rectang(0).Y, ByVal rectang(2).X, ByVal rectang(2).Y)
  Printer.FillStyle = 1
  apustring = "Dead trees"
  Printer.ForeColor = RGB(0, 0, 0)
  apu = TextOut(ByVal apu1, ByVal Box_X + 100, ByVal Box_Y + 325, ByVal apustring, ByVal 30)
 
 End Select
Next k

 apustring = "Kelot alleviivattu"
 Printer.FontUnderline = True
 Printer.FontUnderline = False
 
Rem !!!!!!!!!!!!!!!!!!!!!!
'Call DrawPlotBorders(apu1, "C:\tyo\Marv1_2012\Koealat\122_Kulmat_A.csv", plots(plot).X, plots(plot).Y, CDbl(wmargin), CDbl(ymax), CDbl(hmargin), CDbl(Ltm))
'Call DrawPlotBorders(apu1, "C:\tyo\Marv1_2012\Koealat\122_Kulmat_B.csv", plots(plot).X, plots(plot).Y, CDbl(wmargin), CDbl(ymax), CDbl(hmargin), CDbl(Ltm))
'Call DrawPlotBorders(apu1, "C:\tyo\Marv1_2012\Koealat\3_Kulmat_C.csv", plots(plot).X, plots(plot).Y, CDbl(wmargin), CDbl(ymax), CDbl(hmargin), CDbl(Ltm))
'Call DrawPlotBorders(apu1, "C:\tyo\Marv1_2012\Koealat\3_Kulmat_D.csv", plots(plot).X, plots(plot).Y, CDbl(wmargin), CDbl(ymax), CDbl(hmargin), CDbl(Ltm))
'Call DrawPlotBorders(apu1, "C:\tyo\Marv1_2011\Datan_kokoaminen\1D_corners.csv", plots(plot).X, plots(plot).Y, CDbl(wmargin), CDbl(ymax), CDbl(hmargin), CDbl(Ltm))
'Call DrawPlotBorders(apu1, "F:\marv1\Plot2_Buffer_D.txt", plots(plot).X, plots(plot).Y, CDbl(wmargin), CDbl(ymax), CDbl(hmargin), CDbl(Ltm))

Printer.EndDoc
'MsgBox ("Puita oli " & N)
Close (1)
End Sub



Private Sub Numerolaput_Click()

'On Error GoTo VirheTilanne
CommonDialog1.Filter = "Field plot data files (*.*)|*.*"
CommonDialog1.DialogTitle = "File which has Plot data!"
CommonDialog1.Action = 1
Open CommonDialog1.Filename For Input As 1

' Store this name to a global var,

CSV_Filename = ""
For i = Len(CommonDialog1.Filename) To 1 Step -1
  If Mid(CommonDialog1.Filename, i, 1) <> "\" Then
    CSV_Filename = CSV_Filename & Mid(CommonDialog1.Filename, i, 1)
  Else
  Exit For
  End If
Next i
Dim ad As String
For i = Len(CSV_Filename) To 1 Step -1
  ad = ad & Mid(CSV_Filename, i, 1)
Next i
CSV_Filename = ad


Rem Allocate storage for 2000 tree-observations
ReDim Trees(1 To 3000) As Tree

Rem Read trees in memory
Dim n As Long
n = 1
Do Until EOF(1)
 Input #1, Trees(n).plot, Trees(n).Num, Trees(n).spec, Trees(n).Pos.X, Trees(n).Pos.Y, Trees(n).Pos.z, Trees(n).z_dtm, Trees(n).Lidar_h, Trees(n).Foto_h, Trees(n).d13, Trees(n).state, Trees(n).sigmaX, Trees(n).sigmaY, Trees(n).geoloctype, Trees(n).statusnew, Trees(n).subplot, Trees(n).Strip
 Trees(n).Label = True
 n = n + 1
Loop
Rem Allocate memory for the trees we have
ReDim Preserve Trees(1 To n) As Tree
Close (1)

Rem **********************************************
Rem Printing section
Rem Choose parameter below for the whole area
Dim ymax As Long
hmargin = 10
wmargin = 10
Ltm = 19 ' Scale Unit factor

ymax = CLng(Printer.ScaleHeight / Printer.TwipsPerPixelX)
Rem Define printable area on printer
Pheight = Printer.ScaleHeight
Pwidth = Printer.ScaleWidth
Rem One printer coordinate unit equals in meters (2.5 cm ?)
If Pheight >= Pwidth Then
 Maxdim = Pwidth
 Else
 Maxdim = Pheight
End If

Printer.Circle (1000, 1000), 10
Rem Get the device context
Dim apu1 As Long
apu1 = CLng(Printer.hdc)

Printer.DrawMode = 13
Printer.ForeColor = RGB(0, 0, 0)
Printer.DrawStyle = 0
Printer.FillStyle = 1
Printer.FontName = Arial
Printer.FontSize = 5

Rem Split paper (A4) into 6 labels, with origins at corn(1 to 6)
ReDim corn(1 To 12) As Point2DLong
corn(1).X = 0: corn(2).X = Printer.ScaleWidth / 2: corn(3).X = Printer.ScaleWidth
corn(4).X = 0: corn(5).X = Printer.ScaleWidth / 2: corn(6).X = Printer.ScaleWidth
corn(7).X = 0: corn(8).X = Printer.ScaleWidth / 2: corn(9).X = Printer.ScaleWidth
corn(10).X = 0: corn(11).X = Printer.ScaleWidth / 2: corn(12).X = Printer.ScaleWidth
corn(1).Y = 0: corn(2).Y = 0: corn(3).Y = 0
corn(4).Y = Printer.ScaleHeight * 0.33: corn(5).Y = Printer.ScaleHeight * 0.33: corn(6).Y = Printer.ScaleHeight * 0.33
corn(7).Y = Printer.ScaleHeight * 0.67: corn(8).Y = Printer.ScaleHeight * 0.67: corn(9).Y = Printer.ScaleHeight * 0.67
corn(10).Y = Printer.ScaleHeight: corn(11).Y = Printer.ScaleHeight: corn(12).Y = Printer.ScaleHeight

Dim apustring As String * 60
Rem draw lines between labels

Rem Start processing
Dim orix As Long, oriY As Long, k As Long, sheets As Long
ReDim Ntau(1 To 200) As Long

sheets = 0
m = 0
Dim l As Long
Dim M_in As Long
M_in = 0
For l = 1 To n
 If Trees(l).Label = True Then
  M_in = M_in + 1
  m = m + 1
  Select Case m
  Case 1
  orix = corn(10).X: oriY = corn(10).Y
  Case 2
  orix = corn(11).X: oriY = corn(11).Y
  Case 3
  orix = corn(7).X: oriY = corn(7).Y
  Case 4
  orix = corn(8).X: oriY = corn(8).Y
  Case 5
  orix = corn(4).X: oriY = corn(4).Y
  Case 6
  orix = corn(5).X: oriY = corn(5).Y
  End Select
  Dim distA As Double
  Call FindNeighbors(l, k, Ntau(), distA)
  Rem For trees l there are k neighbors with indeces in Ntau
  Call DrawNumber(apu1, M_in, l, orix, oriY, hmargin, wmargin, ymax)
  Call DrawNeighbors(l, k, Ntau(), apu1, wmargin, hmargin, orix, oriY, ymax, distA)
  If m = 6 Then
    m = 0
    sheets = sheets + 1
    Call DrawLines(apu1, corn(), hmargin, wmargin, ymax)
    Printer.NewPage
  End If
 End If
Next l

done:

Call DrawLines(apu1, corn(), hmargin, wmargin, ymax)



Printer.EndDoc

Exit Sub
VirheTilanne:
MsgBox ("Tapahtui virhe, an error occurred, closing all files, try again")
Close (1)

End Sub
